begin asm
jmp @start
@title:
   db "This program uses self-modifying code to demonstrate (mal)function of rol/ror",0dh,0ah
   db "in DOSBox, when other settings than core=dynamic (auto,simple,normal) are used.",0dh,0ah
   db "There are eight passes for all values to rotate 8...0 times:",0dh,0ah
   db "The first two passes are rol/ror with byte values 00h..0FFh in memory.",0dh,0ah
   db "The second two passes are rol/ror in byte register CH, values 00h..0FFh.",0dh,0ah
   db "These first four ones are with direct (immediately) given values 8..0.",0dh,0ah
   db "The next four passes are the same again, but with values given in register CL.",0dh,0ah,0dh,0ah
   db "vv=value to rotate left/right",0dh,0ah
   db "x=expected resulting carry, with carry clear before",0dh,0ah
   db "X=expected resulting carry, with carry set before",0dh,0ah
   db "r=actual resulting carry, with carry clear before",0dh,0ah
   db "R=actial resulting carry, with carry set before",0dh,0ah,"$"
@head:      db 0dh,0ah,"ROL vv, 8-xX-rR 7-xX-rR 6-xX-rR 5-xX-rR 4-xX-rR 3-xX-rR 2-xX-rR 1-xX-rR 0-xX-rR",0dh,0ah,"$"
@body:      db "rol 00, 8:00 00 7:00 00 6:00 00 5:00 00 4:00 00 3:00 00 2:00 00 1:00 00 0:01 00",0dh,0ah,"$"
@mode:      db 0dh,0ah,"memory,direct$",0dh,0ah,"reg.CH,direct$",0dh,0ah,"memory,reg.CL$",0dh,0ah,"reg.CH,reg.CL$"
@parameter: dw 0000h
@hex:       db "0123456789ABCDEF"
@valid:     db "=!"
@cmd_list:
   rol byte ptr[cs:@parameter],90h
   ror byte ptr[cs:@parameter],90h
   nop
   nop
   nop
   rol ch,90h
   nop
   nop
   nop
   ror ch,90h
   rol byte ptr[cs:@parameter],cl
   nop
   ror byte ptr[cs:@parameter],cl
   nop
   nop
   nop
   nop
   rol ch,cl
   nop
   nop
   nop
   nop
   ror ch,cl
   nop
@start:
   push cs
   pop ds
   mov dx,offset cs:@title
   mov ah,09h
   int 21h
   xor si,si
   mov bp,si
@cmd_loop:
   mov ax,word ptr[cs:si+@cmd_list]
   mov word ptr[cs:@the_command],ax
   mov ax,word ptr[cs:si+@cmd_list+2]
   mov word ptr[cs:@the_command+2],ax
   mov ax,word ptr[cs:si+@cmd_list+4]
   mov word ptr[cs:@the_command+4],ax
   mov dx,bp
   and dx,0f0h
   add dx,offset cs:@mode
   mov ah,09h
   int 21h
   mov dx,offset cs:@head
   int 21h
   mov dx,offset cs:@body
@cmd_loop256:
   mov ch,byte ptr[cs:@parameter+1]
   mov bl,ch
   and bx,0fh
   mov ah,byte ptr[cs:bx+@hex]
   mov bh,ch
   shr bx,0ch
   mov al,byte ptr[cs:bx+@hex]
   mov word ptr[cs:@body+4],ax
   mov di,offset cs:@body+0ah
@cmd_clear_zero:
   mov al,18h
@to_modify_shift:
   shr ch,1
   adc al,al
   mov ah,al
   mov word ptr[cs:di],ax
   add di,8
   add bh,20h
   jnz @cmd_clear_zero
   sub di,3dh
   mov cl,8
@to_modify_jump:
   mov byte ptr[cs:@rotate_value],cl
   jmp @cmd_loop9
@cmd_loop9:
   mov ax,1818h
@inner_loop:
   mov ch,byte ptr[cs:@parameter+1]
   mov byte ptr[cs:@parameter],ch
@the_carry:
   clc
@the_command:
   nop
   nop
   nop
   nop
   nop
@rotate_value:
   db 8
   adc al,al
   xchg al,ah
   xor byte ptr[cs:@the_carry],01h
   jp @inner_loop
   mov word ptr[cs:di],ax
   cmp ax,word ptr[cs:di-3]
   lahf
   shl ah,2
   sbb bx,bx
   mov al,byte ptr[cs:bx+@valid+1]
   mov byte ptr[cs:di-1],al
   add di,8
   sub byte ptr[cs:@rotate_value],1
@to_modify_dec:
   dec cl
   jns @cmd_loop9
   mov ah,09h
   int 21h
   inc byte ptr[cs:@parameter+1]
   jnz @cmd_loop256
   xor byte ptr[cs:@to_modify_shift+1],08h
   xor byte ptr[cs:@head+4],1eh
   xor byte ptr[cs:@body+2],1eh
   add bp,4008h
   jnc @noflipcommmand
   xor word ptr[cs:@to_modify_jump],8dc5h
   xor byte ptr[cs:@to_modify_dec-1],01h
@noflipcommmand:
   add si,06h
   cmp si,30h
   jb @cmd_loop
end;end.
